-------------------------------------------------------------------------------
-- Blizzard Finnegan
-- single bit full adder [behavioral]
-------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;      

entity full_adder_single_bit_beh is 
  port (
    a       : in std_logic;
    b       : in std_logic;
    cin     : in std_logic;
    sum     : out std_logic;
    cout    : out std_logic
  );
end full_adder_single_bit_beh;

architecture arch of full_adder_single_bit_beh is

component alu_and 
  port (
    a     : in  std_logic;
    b     : in  std_logic;
    cout  : out std_logic
  );
end component;

component alu_3or 
  port (
    a     : in  std_logic;
    b     : in  std_logic;
    c     : in  std_logic;
    cout  : out std_logic
  );
end component;

component alu_xor 
  port (
    a     : in  std_logic;
    b     : in  std_logic;
    cout  : out std_logic
  );
end component;

signal ab:std_logic;
signal bcin:std_logic;
signal acin:std_logic;
signal axb:std_logic;


begin 

and1: alu_and
  port map(
  a => a,
  b => b,
  cout => ab
  );

and2: alu_and
  port map(
  a => a,
  b => cin,
  cout => acin
  );

and3: alu_and
  port map(
  a => b,
  b => cin,
  cout => bcin
  );

xor1: alu_xor
  port map(
  a => a,
  b => b,
  cout => axb
  );

xor2: alu_xor
  port map(
  a => axb,
  b => cin,
  cout => sum
  );

or1: alu_3or
  port map(
  a => ab,
  b => bcin,
  c => acin,
  cout => cout
  );

end arch; 
